// =====================================================================
/*!
//
//  \file TDataSection.hh
//  \brief This file contains the TDataSection class.
//  \author Go IWAI <goiwai@users.sourceforge.jp>
//
//  $Id: TDataSection.hh,v 1.10 2004/03/07 10:30:30 goiwai Exp $
//  $Name: CLDAQ-1-14-06 $
//  $Log: TDataSection.hh,v $
//  Revision 1.10  2004/03/07 10:30:30  goiwai
//  ROOTに組みこむためのおまじないマクロを埋めこみました。
//  全てにおいて完全に動作するわけではありません。
//
//  Revision 1.9  2004/01/19 21:09:39  goiwai
//  プリプロセッサの接頭辞をCLDAQ__に変更しました.
//
//  Revision 1.8  2003/12/06 10:59:11  goiwai
//  Serialize(Tvoid*) -> Serialize(const Tvoid*)に変更しました.
//  Deserialize(const Tvoid*)を追加しました.
//  手抜きの実装なので,バッファオーバーフローの可能性があります.
//  Reallocate()とかするような仕組みが必要です.
//
//  Revision 1.7  2003/11/24 06:56:13  goiwai
//  Size()メンバ関数を追加しました.
//  抱えているDataSegmentの数を返します.
//
//  Revision 1.6  2003/11/04 12:03:05  goiwai
//  ==演算子と!=演算子を実装しました.具体的には
//  if ( record == "String" ) {
//    hoeghoge;
//  }
//  のような使い方が出来ます.単純に theID メンバとを比較して結果を返します.
//
//  Revision 1.5  2003/11/03 08:35:12  goiwai
//  Doxygen用のタグとコメントをうちこんでいく試みを開始しました.
//
//  Revision 1.4  2003/10/06 16:42:19  goiwai
//  *** empty log message ***
//
//  Revision 1.3  2003/08/25 09:20:29  goiwai
//  operator[]( const Tstring& id ) を加えました.
//  record[0] とか record["tag"] とかすれば, TDataSegment を得ることが出来
//  ます.
//  size()を越えた範囲にも,チェックしないでアクセスします.
//  マッチしなかった場合は落ちます.
//  同じ名前でタグされた DataSegment がある場合,最初にマッチしたものが返っ
//  てきます.
//
//  Revision 1.2  2003/07/30 16:17:51  goiwai
//  ファイルにコミットログをつけることにしました.
//
*/
// =====================================================================
#ifndef CLDAQ__TDATASECTION_HH
#define CLDAQ__TDATASECTION_HH

#include "Tglobals.h"
#include "TStreamableObject.hh"
#include "TDataSegmentList.hh"

class TOutputObjectStream;
class TOutputObjectFile;
class TOutputObjectSocket;
class TOutputObjectSharedMemory;


/*!
// \example
//
// If example code exists.
//
*/

/*!
// \class TDataSection
// \brief This is the TDataSection class.
// \author Go IWAI <goiwai@users.sourceforge.jp>
//
// The TDataSection class detail description.
// Write it down ASAP!
//
// \todo None?
// \bug None?
// \ingroup DatarecordCategory
*/
class TDataSection
  : public TStreamableObject, public TDataSegmentList
{

  public:
    TDataSection( const Tstring& id = TunknownID );
    TDataSection( const TDataSection& right );  
    ~TDataSection();

  public:
    Tint GetRecordSize();
    Tint Record( TOutputObjectStream* objectfile );
    Tvoid Clear();
    Tint Serialize( const Tvoid* buffer );
    Tint Deserialize( const Tvoid* buffer );
    Tint Size() const;

  public:
    const TDataSection& operator=( const TDataSection& right );
    Tbool operator==( const TDataSection& right ) const;
    Tbool operator!=( const TDataSection& right ) const;
    Tbool operator==( const Tstring& right ) const;
    Tbool operator!=( const Tstring& right ) const;
    const TDataSegment& operator[]( Tint n ) const;
    TDataSegment& operator[]( Tint n );
    const TDataSegment& operator[]( const Tstring& id ) const;
    TDataSegment& operator[]( const Tstring& id );
    friend Tostream& operator<<( Tostream& tos, const TDataSection& right );

  public:
    Tbool FindDataSegment( const Tstring& id, TDataSegment& segment ) const;
    Tint FindDataSegment( const Tstring& id ) const;
    Tbool FindDataElement( const Tstring& segid, const Tstring& eleid, TDataElement& element ) const;
    Tint FindDataElement( const Tstring& segid, const Tstring& eleid ) const;
    Tbool FindDataElement( Tstring idset[ 2 ], TDataElement& element ) const;
    Tint FindDataElement( Tstring idset[ 2 ] ) const;
    Tbool FindDataElement( const TstringList& idset, TDataElement& element ) const;
    Tint FindDataElement( const TstringList& idset ) const;

  private:
    Tint record( TOutputObjectFile* ofile );
    Tint record( TOutputObjectSocket* osocket );
    Tint record( TOutputObjectSharedMemory* omemory );

#ifdef __CLDAQ_ROOT_DLL
    ClassDef(TDataSection,0)
#endif

};

inline Tint TDataSection::Size() const
{
  return (Tint)size();
}

#endif
